commit:     06150adeff078a4cefa44939362f24059dbabfc2
Author:     William Hubbs <williamh <AT> gentoo <DOT> org>
AuthorDate: Wed May  4 19:00:49 2022 +0000
Commit:     William Hubbs <williamh <AT> gentoo <DOT> org>
CommitDate: Wed May  4 19:01:47 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=06150ade

Revert "net-libs/nodejs: drop 12.22.5-r1, 12.22.6, 12.22.10"

This reverts commit d790231b88ab650ac50f754719fa515128ce1119.
let's wait for node 18 to go stable.

Signed-off-by: William Hubbs <williamh <AT> gentoo.org>

 net-libs/nodejs/Manifest                           |   3 +
 .../files/nodejs-12.20.1-fix_ppc64_crashes.patch   |  44 ++++
 .../nodejs-12.22.1-jinja_collections_abc.patch     |  95 ++++++++
 net-libs/nodejs/nodejs-12.22.10.ebuild             | 249 +++++++++++++++++++++
 net-libs/nodejs/nodejs-12.22.5-r1.ebuild           | 249 +++++++++++++++++++++
 net-libs/nodejs/nodejs-12.22.6.ebuild              | 249 +++++++++++++++++++++
 6 files changed, 889 insertions(+)

diff --git a/net-libs/nodejs/Manifest b/net-libs/nodejs/Manifest
index 0c6c3c7600cc..0b7285ce5651 100644
--- a/net-libs/nodejs/Manifest
+++ b/net-libs/nodejs/Manifest
@@ -1,3 +1,6 @@
+DIST node-v12.22.10.tar.xz 24089580 BLAKE2B 
0ecf0b2ed64cba1bbcab287ccf7e524bd08ce787399d01fb792fd5232983289403a85810bc6eccd090b6d15796c48dc6ea3baf0cb3154e392dc343da53086b81
 SHA512 
da984e98856ef89eb259346d9d1eae60ff3d255d964f3b09d59851a9c21c86acd0c56b9c888f61423de07afab1c09946c00856c832a1f1a8abc4c671c31e23b1
+DIST node-v12.22.5.tar.xz 23654908 BLAKE2B 
ca4f304e31f091ae656142035851d6e4427d8b2ddd2a69506dec96efbb1269a19a08e9ab8d44dfe10f8429bc239e4102f3f030adb25e9c41901c7d94b53e88c8
 SHA512 
80f3c673a1f2af7fffd6aaa556c06b8225034c8413e1a738c19d491aff1b3e6ed388df66ecbff88e4bfbefe1013dac7e3beb301456c2099b6a954ba468b21883
+DIST node-v12.22.6.tar.xz 23664904 BLAKE2B 
04dd4fd4cbe39642a1c3dd8639a4d9e3362055f56bc2565303d0095cda1655033ba4e0ce5a969647d2be73df13ddbcccc4907825a94a41b45c0723b3c02ca980
 SHA512 
d107f1ff7073d2db9f0198f14b0523870e9b262c71055de2e03fba54f87bc98a57dad43d902c0b349957df21de71dc066133d4831eb7eb07f4e548d0ac724fb2
 DIST node-v14.17.5.tar.xz 33585724 BLAKE2B 
cf79397caad8c81e4096f344f9fdb88d8ecea44b97fe208256dfd4afb750ecdf52142a2dc0430285b9d5117bdd43fa5ce42b4418926eec4d2c7f0a5f5d1a1539
 SHA512 
9d62c8946d05862d96a13a71b241a097b9f592a9e5f7362c81d8f3c74e7c5546a308b4c74bef34a66cafeef5d1a87d9d3e5ae8bb87d470c1ecf5abb8de0dedb5
 DIST node-v14.17.6.tar.xz 33606464 BLAKE2B 
c2c449e5eaf8214d7ed4bfab8db0208034cee1d08ef0e1fca478c30fc5cf95be037eb141080dbcfbe4fc58ef734457747dcbd0fe585a0536f9c0bec495435f25
 SHA512 
581c5698112426042fbf54fa793e56a30cae0c54ce8f23af6ac20d73c69a4f1166c5410f357c5a7b0409a773f99e3b9291e4afffd53b3c0e00569725dc4c47d3
 DIST node-v14.19.0.tar.xz 34486868 BLAKE2B 
12e571a366c1d4b2475ef258e338f516bb81e9c08f7e6b7f951decbf371028cdcf32c72181d8504d0890496eaecce0d6b23437b8dad6c6e498d30bf6636bd1e7
 SHA512 
80573fa3a0882c1f2a40b991f187f49714748ca4c56c78133e2d2be0322f201816eb059a1a7d38ea8a925229c1b1324d0ffc28ff4002d0115bfae44fe87efe97

diff --git a/net-libs/nodejs/files/nodejs-12.20.1-fix_ppc64_crashes.patch 
b/net-libs/nodejs/files/nodejs-12.20.1-fix_ppc64_crashes.patch
new file mode 100644
index 000000000000..0982d3c81c2a
--- /dev/null
+++ b/net-libs/nodejs/files/nodejs-12.20.1-fix_ppc64_crashes.patch
@@ -0,0 +1,44 @@
+Backport of https://github.com/nodejs/node/pull/33866 to nodejs-12
+
+--- a/deps/v8/src/compiler/backend/instruction-selector.cc
++++ b/deps/v8/src/compiler/backend/instruction-selector.cc
+@@ -2788,7 +2788,7 @@
+   switch (call_descriptor->kind()) {
+     case CallDescriptor::kCallAddress: {
+       int misc_field = static_cast<int>(call_descriptor->ParameterCount());
+-#if defined(_AIX)
++#if ABI_USES_FUNCTION_DESCRIPTORS
+       // Highest misc_field bit is used on AIX to indicate if a CFunction call
+       // has function descriptor or not.
+       misc_field |= call_descriptor->HasFunctionDescriptor()
+--- a/deps/v8/src/compiler/backend/ppc/code-generator-ppc.cc
++++ b/deps/v8/src/compiler/backend/ppc/code-generator-ppc.cc
+@@ -1026,7 +1026,7 @@
+       Label start_call;
+       bool isWasmCapiFunction =
+           linkage()->GetIncomingDescriptor()->IsWasmCapiFunction();
+-#if defined(_AIX)
++#if ABI_USES_FUNCTION_DESCRIPTORS
+       // AIX/PPC64BE Linux uses a function descriptor
+       int kNumParametersMask = kHasFunctionDescriptorBitMask - 1;
+       num_parameters = kNumParametersMask & misc_field;
+--- a/deps/v8/src/execution/simulator.h
++++ b/deps/v8/src/execution/simulator.h
+@@ -122,7 +122,7 @@
+ 
+   DISABLE_CFI_ICALL Return Call(Args... args) {
+     // When running without a simulator we call the entry directly.
+-#if V8_OS_AIX
++#if ABI_USES_FUNCTION_DESCRIPTORS
+     // AIX ABI requires function descriptors (FD).  Artificially create a 
pseudo
+     // FD to ensure correct dispatch to generated code.  The 'volatile'
+     // declaration is required to avoid the compiler from not observing the
+@@ -134,7 +134,7 @@
+     return fn(args...);
+ #else
+     return fn_ptr_(args...);
+-#endif  // V8_OS_AIX
++#endif  // ABI_USES_FUNCTION_DESCRIPTORS
+   }
+ #endif  // USE_SIMULATOR
+ 

diff --git a/net-libs/nodejs/files/nodejs-12.22.1-jinja_collections_abc.patch 
b/net-libs/nodejs/files/nodejs-12.22.1-jinja_collections_abc.patch
new file mode 100644
index 000000000000..5f0df09b6e2e
--- /dev/null
+++ b/net-libs/nodejs/files/nodejs-12.22.1-jinja_collections_abc.patch
@@ -0,0 +1,95 @@
+--- a/deps/v8/third_party/jinja2/tests.py
++++ b/deps/v8/third_party/jinja2/tests.py
+@@ -10,7 +10,7 @@
+ """
+ import operator
+ import re
+-from collections import Mapping
++from collections.abc import Mapping
+ from jinja2.runtime import Undefined
+ from jinja2._compat import text_type, string_types, integer_types
+ import decimal
+--- a/deps/v8/third_party/jinja2/runtime.py
++++ b/deps/v8/third_party/jinja2/runtime.py
+@@ -315,7 +315,7 @@ class Context(with_metaclass(ContextMeta)):
+ 
+ # register the context as mapping if possible
+ try:
+-    from collections import Mapping
++    from collections.abc import Mapping
+     Mapping.register(Context)
+ except ImportError:
+     pass
+--- a/deps/v8/third_party/jinja2/sandbox.py
++++ b/deps/v8/third_party/jinja2/sandbox.py
+@@ -14,7 +14,7 @@
+ """
+ import types
+ import operator
+-from collections import Mapping
++from collections.abc import Mapping
+ from jinja2.environment import Environment
+ from jinja2.exceptions import SecurityError
+ from jinja2._compat import string_types, PY2
+@@ -79,7 +79,7 @@ except ImportError:
+     pass
+ 
+ #: register Python 2.6 abstract base classes
+-from collections import MutableSet, MutableMapping, MutableSequence
++from collections.abc import MutableSet, MutableMapping, MutableSequence
+ _mutable_set_types += (MutableSet,)
+ _mutable_mapping_types += (MutableMapping,)
+ _mutable_sequence_types += (MutableSequence,)
+--- a/deps/v8/third_party/jinja2/utils.py
++++ b/deps/v8/third_party/jinja2/utils.py
+@@ -482,7 +482,7 @@ class LRUCache(object):
+ 
+ # register the LRU cache as mutable mapping if possible
+ try:
+-    from collections import MutableMapping
++    from collections.abc import MutableMapping
+     MutableMapping.register(LRUCache)
+ except ImportError:
+     pass
+--- a/tools/inspector_protocol/jinja2/runtime.py
++++ b/tools/inspector_protocol/jinja2/runtime.py
+@@ -315,7 +315,7 @@ class Context(with_metaclass(ContextMeta)):
+ 
+ # register the context as mapping if possible
+ try:
+-    from collections import Mapping
++    from collections.abc import Mapping
+     Mapping.register(Context)
+ except ImportError:
+     pass
+--- a/tools/inspector_protocol/jinja2/sandbox.py
++++ b/tools/inspector_protocol/jinja2/sandbox.py
+@@ -14,7 +14,7 @@
+ """
+ import types
+ import operator
+-from collections import Mapping
++from collections.abc import Mapping
+ from jinja2.environment import Environment
+ from jinja2.exceptions import SecurityError
+ from jinja2._compat import string_types, PY2
+@@ -79,7 +79,7 @@ except ImportError:
+     pass
+ 
+ #: register Python 2.6 abstract base classes
+-from collections import MutableSet, MutableMapping, MutableSequence
++from collections.abc import MutableSet, MutableMapping, MutableSequence
+ _mutable_set_types += (MutableSet,)
+ _mutable_mapping_types += (MutableMapping,)
+ _mutable_sequence_types += (MutableSequence,)
+--- a/tools/inspector_protocol/jinja2/tests.py
++++ b/tools/inspector_protocol/jinja2/tests.py
+@@ -10,7 +10,7 @@
+ """
+ import operator
+ import re
+-from collections import Mapping
++from collections.abc import Mapping
+ from jinja2.runtime import Undefined
+ from jinja2._compat import text_type, string_types, integer_types
+ import decimal

diff --git a/net-libs/nodejs/nodejs-12.22.10.ebuild 
b/net-libs/nodejs/nodejs-12.22.10.ebuild
new file mode 100644
index 000000000000..4638f6304808
--- /dev/null
+++ b/net-libs/nodejs/nodejs-12.22.10.ebuild
@@ -0,0 +1,249 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{8..10} )
+PYTHON_REQ_USE="threads(+)"
+
+inherit bash-completion-r1 flag-o-matic pax-utils python-any-r1 
toolchain-funcs xdg-utils
+
+DESCRIPTION="A JavaScript runtime built on Chrome's V8 JavaScript engine"
+HOMEPAGE="https://nodejs.org/";
+LICENSE="Apache-1.1 Apache-2.0 BSD BSD-2 MIT"
+
+if [[ ${PV} == *9999 ]]; then
+       inherit git-r3
+       EGIT_REPO_URI="https://github.com/nodejs/node";
+       SLOT="0"
+else
+       SRC_URI="https://nodejs.org/dist/v${PV}/node-v${PV}.tar.xz";
+       SLOT="0/$(ver_cut 1)"
+       KEYWORDS="amd64 ~arm arm64 ppc64 -riscv x86 ~amd64-linux ~x64-macos"
+       S="${WORKDIR}/node-v${PV}"
+fi
+
+IUSE="cpu_flags_x86_sse2 debug doc icu inspector lto +npm +snapshot +ssl 
+system-ssl systemtap test"
+REQUIRED_USE="
+       inspector? ( icu ssl )
+       npm? ( ssl )
+       system-ssl? ( ssl )
+"
+
+RESTRICT="!test? ( test )"
+
+RDEPEND="
+       >=app-arch/brotli-1.0.9:=
+       >=dev-libs/libuv-1.39.0:=
+       >=net-dns/c-ares-1.17.2:=
+       >=net-libs/http-parser-2.9.3:=
+       >=net-libs/nghttp2-1.40.0:=
+       sys-libs/zlib
+       icu? ( >=dev-libs/icu-64.2:= )
+       system-ssl? (
+               >=dev-libs/openssl-1.1.1:0=
+               <dev-libs/openssl-3.0.0_beta1:0=
+       )
+"
+BDEPEND="
+       ${PYTHON_DEPS}
+       sys-apps/coreutils
+       virtual/pkgconfig
+       systemtap? ( dev-util/systemtap )
+       test? ( net-misc/curl )
+"
+DEPEND="
+       ${RDEPEND}
+"
+PATCHES=(
+       "${FILESDIR}"/${P}-global-npm-config.patch
+       "${FILESDIR}"/${PN}-12.20.1-fix_ppc64_crashes.patch
+       "${FILESDIR}"/${PN}-12.22.1-jinja_collections_abc.patch
+       "${FILESDIR}"/${PN}-12.22.1-uvwasi_shared_libuv.patch
+       "${FILESDIR}"/${PN}-12.22.5-shared_c-ares_nameser_h.patch
+       "${FILESDIR}"/${PN}-99999999-llhttp.patch
+)
+
+pkg_pretend() {
+       (use x86 && ! use cpu_flags_x86_sse2) && \
+               die "Your CPU doesn't support the required SSE2 instruction."
+
+       if [[ ${MERGE_TYPE} != "binary" ]]; then
+               if use lto; then
+                       if tc-is-gcc; then
+                               if [[ $(gcc-major-version) -ge 11 ]]; then
+                                       # Bug #787158
+                                       die "LTO builds of ${PN} using gcc-11+ 
currently fail tests and produce runtime errors. Either switch to gcc-10 or 
unset USE=lto for this ebuild"
+                               fi
+                       else
+                               # configure.py will abort on this later if we 
do not
+                               die "${PN} only supports LTO for gcc"
+                       fi
+               fi
+       fi
+}
+
+src_prepare() {
+       tc-export CC CXX PKG_CONFIG
+       export V=1
+       export BUILDTYPE=Release
+
+       # fix compilation on Darwin
+       # https://code.google.com/p/gyp/issues/detail?id=260
+       sed -i -e "/append('-arch/d" tools/gyp/pylib/gyp/xcode_emulation.py || 
die
+
+       # less verbose install output (stating the same as portage, basically)
+       sed -i -e "/print/d" tools/install.py || die
+
+       # proper libdir, hat tip @ryanpcmcquen 
https://github.com/iojs/io.js/issues/504
+       local LIBDIR=$(get_libdir)
+       sed -i -e "s|lib/|${LIBDIR}/|g" tools/install.py || die
+       sed -i -e "s/'lib'/'${LIBDIR}'/" deps/npm/lib/npm.js || die
+
+       # Avoid writing a depfile, not useful
+       sed -i -e "/DEPFLAGS =/d" tools/gyp/pylib/gyp/generator/make.py || die
+
+       sed -i -e "/'-O3'/d" common.gypi node.gypi || die
+
+       # Known-to-fail test of a deprecated, legacy HTTP parser. Just don't 
bother.
+       rm -f test/parallel/test-http-transfer-encoding-smuggling-legacy.js
+
+       # debug builds. change install path, remove optimisations and override 
buildtype
+       if use debug; then
+               sed -i -e "s|out/Release/|out/Debug/|g" tools/install.py || die
+               BUILDTYPE=Debug
+       fi
+
+       default
+}
+
+src_configure() {
+       xdg_environment_reset
+
+       # LTO compiler flags are handled by configure.py itself
+       filter-flags '-flto*'
+
+       local myconf=(
+               --shared-brotli
+               --shared-cares
+               --shared-http-parser
+               --shared-libuv
+               --shared-nghttp2
+               --shared-zlib
+       )
+       use debug && myconf+=( --debug )
+       use lto && myconf+=( --enable-lto )
+       use icu && myconf+=( --with-intl=system-icu ) || myconf+=( 
--with-intl=none )
+       use inspector || myconf+=( --without-inspector )
+       use npm || myconf+=( --without-npm )
+       use snapshot || myconf+=( --without-node-snapshot )
+       if use ssl; then
+               use system-ssl && myconf+=( --shared-openssl 
--openssl-use-def-ca-store )
+       else
+               myconf+=( --without-ssl )
+       fi
+
+       local myarch=""
+       case ${ABI} in
+               amd64) myarch="x64";;
+               arm) myarch="arm";;
+               arm64) myarch="arm64";;
+               ppc64) myarch="ppc64";;
+               x32) myarch="x32";;
+               x86) myarch="ia32";;
+               *) myarch="${ABI}";;
+       esac
+
+       GYP_DEFINES="linux_use_gold_flags=0
+               linux_use_bundled_binutils=0
+               linux_use_bundled_gold=0" \
+       "${EPYTHON}" configure.py \
+               --prefix="${EPREFIX}"/usr \
+               --dest-cpu=${myarch} \
+               $(use_with systemtap dtrace) \
+               "${myconf[@]}" || die
+}
+
+src_compile() {
+       emake -C out mksnapshot
+       pax-mark m "out/${BUILDTYPE}/mksnapshot"
+       emake -C out
+}
+
+src_install() {
+       local LIBDIR="${ED}/usr/$(get_libdir)"
+       default
+
+       pax-mark -m "${ED}"/usr/bin/node
+
+       # set up a symlink structure that node-gyp expects..
+       dodir /usr/include/node/deps/{v8,uv}
+       dosym . /usr/include/node/src
+       for var in deps/{uv,v8}/include; do
+               dosym ../.. /usr/include/node/${var}
+       done
+
+       if use doc; then
+               docinto html
+               dodoc -r "${S}"/doc/*
+       fi
+
+       if use npm; then
+               dodir /etc/npm
+
+               # Install bash completion for `npm`
+               # We need to temporarily replace default config path since
+               # npm otherwise tries to write outside of the sandbox
+               local 
npm_config="usr/$(get_libdir)/node_modules/npm/lib/config/core.js"
+               sed -i -e "s|'/etc'|'${ED}/etc'|g" "${ED}/${npm_config}" || die
+               local tmp_npm_completion_file="$(TMPDIR="${T}" mktemp -t 
npm.XXXXXXXXXX)"
+               "${ED}/usr/bin/npm" completion > "${tmp_npm_completion_file}"
+               newbashcomp "${tmp_npm_completion_file}" npm
+               sed -i -e "s|'${ED}/etc'|'/etc'|g" "${ED}/${npm_config}" || die
+
+               # Move man pages
+               doman "${LIBDIR}"/node_modules/npm/man/man{1,5,7}/*
+
+               # Clean up
+               rm -f 
"${LIBDIR}"/node_modules/npm/{.mailmap,.npmignore,Makefile}
+               rm -rf "${LIBDIR}"/node_modules/npm/{doc,html,man}
+
+               local find_exp="-or -name"
+               local find_name=()
+               for match in "AUTHORS*" "CHANGELOG*" "CONTRIBUT*" "README*" \
+                       ".travis.yml" ".eslint*" ".wercker.yml" ".npmignore" \
+                       "*.md" "*.markdown" "*.bat" "*.cmd"; do
+                       find_name+=( ${find_exp} "${match}" )
+               done
+
+               # Remove various development and/or inappropriate files and
+               # useless docs of dependend packages.
+               find "${LIBDIR}"/node_modules \
+                       \( -type d -name examples \) -or \( -type f \( \
+                               -iname "LICEN?E*" \
+                               "${find_name[@]}" \
+                       \) \) -exec rm -rf "{}" \;
+       fi
+
+       mv "${ED}"/usr/share/doc/node "${ED}"/usr/share/doc/${PF} || die
+}
+
+src_test() {
+       if has usersandbox ${FEATURES}; then
+               rm -f "${S}"/test/parallel/test-fs-mkdir.js
+               ewarn "You are emerging ${PN} with 'usersandbox' enabled. 
Excluding tests known to fail in this mode." \
+                       "For full test coverage, emerge =${CATEGORY}/${PF} with 
'FEATURES=-usersandbox'."
+       fi
+
+       out/${BUILDTYPE}/cctest || die
+       "${PYTHON}" tools/test.py --mode=${BUILDTYPE,,} --flaky-tests=dontcare 
-J message parallel sequential || die
+}
+
+pkg_postinst() {
+       elog "The global npm config lives in /etc/npm. This deviates slightly"
+       elog "from upstream which otherwise would have it live in /usr/etc/."
+       elog ""
+       elog "Protip: When using node-gyp to install native modules, you can"
+       elog "avoid having to download extras by doing the following:"
+       elog "$ node-gyp --nodedir /usr/include/node <command>"
+}

diff --git a/net-libs/nodejs/nodejs-12.22.5-r1.ebuild 
b/net-libs/nodejs/nodejs-12.22.5-r1.ebuild
new file mode 100644
index 000000000000..1e716cbf5e85
--- /dev/null
+++ b/net-libs/nodejs/nodejs-12.22.5-r1.ebuild
@@ -0,0 +1,249 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{8..10} )
+PYTHON_REQ_USE="threads(+)"
+
+inherit bash-completion-r1 flag-o-matic pax-utils python-any-r1 
toolchain-funcs xdg-utils
+
+DESCRIPTION="A JavaScript runtime built on Chrome's V8 JavaScript engine"
+HOMEPAGE="https://nodejs.org/";
+LICENSE="Apache-1.1 Apache-2.0 BSD BSD-2 MIT"
+
+if [[ ${PV} == *9999 ]]; then
+       inherit git-r3
+       EGIT_REPO_URI="https://github.com/nodejs/node";
+       SLOT="0"
+else
+       SRC_URI="https://nodejs.org/dist/v${PV}/node-v${PV}.tar.xz";
+       SLOT="0/$(ver_cut 1)"
+       KEYWORDS="amd64 arm arm64 ppc64 -riscv x86 ~amd64-linux ~x64-macos"
+       S="${WORKDIR}/node-v${PV}"
+fi
+
+IUSE="cpu_flags_x86_sse2 debug doc icu inspector lto +npm +snapshot +ssl 
+system-ssl systemtap test"
+REQUIRED_USE="
+       inspector? ( icu ssl )
+       npm? ( ssl )
+       system-ssl? ( ssl )
+"
+
+RESTRICT="!test? ( test )"
+
+RDEPEND="
+       >=app-arch/brotli-1.0.9:=
+       >=dev-libs/libuv-1.39.0:=
+       >=net-dns/c-ares-1.17.2:=
+       >=net-libs/http-parser-2.9.3:=
+       >=net-libs/nghttp2-1.40.0:=
+       sys-libs/zlib
+       icu? ( >=dev-libs/icu-64.2:= )
+       system-ssl? (
+               >=dev-libs/openssl-1.1.1:0=
+               <dev-libs/openssl-3.0.0_beta1:0=
+       )
+"
+BDEPEND="
+       ${PYTHON_DEPS}
+       sys-apps/coreutils
+       virtual/pkgconfig
+       systemtap? ( dev-util/systemtap )
+       test? ( net-misc/curl )
+"
+DEPEND="
+       ${RDEPEND}
+"
+PATCHES=(
+       "${FILESDIR}"/${PN}-10.3.0-global-npm-config.patch
+       "${FILESDIR}"/${PN}-12.20.1-fix_ppc64_crashes.patch
+       "${FILESDIR}"/${PN}-12.22.1-jinja_collections_abc.patch
+       "${FILESDIR}"/${PN}-12.22.1-uvwasi_shared_libuv.patch
+       "${FILESDIR}"/${PN}-12.22.5-shared_c-ares_nameser_h.patch
+       "${FILESDIR}"/${PN}-99999999-llhttp.patch
+)
+
+pkg_pretend() {
+       (use x86 && ! use cpu_flags_x86_sse2) && \
+               die "Your CPU doesn't support the required SSE2 instruction."
+
+       if [[ ${MERGE_TYPE} != "binary" ]]; then
+               if use lto; then
+                       if tc-is-gcc; then
+                               if [[ $(gcc-major-version) -ge 11 ]]; then
+                                       # Bug #787158
+                                       die "LTO builds of ${PN} using gcc-11+ 
currently fail tests and produce runtime errors. Either switch to gcc-10 or 
unset USE=lto for this ebuild"
+                               fi
+                       else
+                               # configure.py will abort on this later if we 
do not
+                               die "${PN} only supports LTO for gcc"
+                       fi
+               fi
+       fi
+}
+
+src_prepare() {
+       tc-export CC CXX PKG_CONFIG
+       export V=1
+       export BUILDTYPE=Release
+
+       # fix compilation on Darwin
+       # https://code.google.com/p/gyp/issues/detail?id=260
+       sed -i -e "/append('-arch/d" tools/gyp/pylib/gyp/xcode_emulation.py || 
die
+
+       # less verbose install output (stating the same as portage, basically)
+       sed -i -e "/print/d" tools/install.py || die
+
+       # proper libdir, hat tip @ryanpcmcquen 
https://github.com/iojs/io.js/issues/504
+       local LIBDIR=$(get_libdir)
+       sed -i -e "s|lib/|${LIBDIR}/|g" tools/install.py || die
+       sed -i -e "s/'lib'/'${LIBDIR}'/" deps/npm/lib/npm.js || die
+
+       # Avoid writing a depfile, not useful
+       sed -i -e "/DEPFLAGS =/d" tools/gyp/pylib/gyp/generator/make.py || die
+
+       sed -i -e "/'-O3'/d" common.gypi node.gypi || die
+
+       # Known-to-fail test of a deprecated, legacy HTTP parser. Just don't 
bother.
+       rm -f test/parallel/test-http-transfer-encoding-smuggling-legacy.js
+
+       # debug builds. change install path, remove optimisations and override 
buildtype
+       if use debug; then
+               sed -i -e "s|out/Release/|out/Debug/|g" tools/install.py || die
+               BUILDTYPE=Debug
+       fi
+
+       default
+}
+
+src_configure() {
+       xdg_environment_reset
+
+       # LTO compiler flags are handled by configure.py itself
+       filter-flags '-flto*'
+
+       local myconf=(
+               --shared-brotli
+               --shared-cares
+               --shared-http-parser
+               --shared-libuv
+               --shared-nghttp2
+               --shared-zlib
+       )
+       use debug && myconf+=( --debug )
+       use lto && myconf+=( --enable-lto )
+       use icu && myconf+=( --with-intl=system-icu ) || myconf+=( 
--with-intl=none )
+       use inspector || myconf+=( --without-inspector )
+       use npm || myconf+=( --without-npm )
+       use snapshot || myconf+=( --without-node-snapshot )
+       if use ssl; then
+               use system-ssl && myconf+=( --shared-openssl 
--openssl-use-def-ca-store )
+       else
+               myconf+=( --without-ssl )
+       fi
+
+       local myarch=""
+       case ${ABI} in
+               amd64) myarch="x64";;
+               arm) myarch="arm";;
+               arm64) myarch="arm64";;
+               ppc64) myarch="ppc64";;
+               x32) myarch="x32";;
+               x86) myarch="ia32";;
+               *) myarch="${ABI}";;
+       esac
+
+       GYP_DEFINES="linux_use_gold_flags=0
+               linux_use_bundled_binutils=0
+               linux_use_bundled_gold=0" \
+       "${EPYTHON}" configure.py \
+               --prefix="${EPREFIX}"/usr \
+               --dest-cpu=${myarch} \
+               $(use_with systemtap dtrace) \
+               "${myconf[@]}" || die
+}
+
+src_compile() {
+       emake -C out mksnapshot
+       pax-mark m "out/${BUILDTYPE}/mksnapshot"
+       emake -C out
+}
+
+src_install() {
+       local LIBDIR="${ED}/usr/$(get_libdir)"
+       default
+
+       pax-mark -m "${ED}"/usr/bin/node
+
+       # set up a symlink structure that node-gyp expects..
+       dodir /usr/include/node/deps/{v8,uv}
+       dosym . /usr/include/node/src
+       for var in deps/{uv,v8}/include; do
+               dosym ../.. /usr/include/node/${var}
+       done
+
+       if use doc; then
+               docinto html
+               dodoc -r "${S}"/doc/*
+       fi
+
+       if use npm; then
+               dodir /etc/npm
+
+               # Install bash completion for `npm`
+               # We need to temporarily replace default config path since
+               # npm otherwise tries to write outside of the sandbox
+               local 
npm_config="usr/$(get_libdir)/node_modules/npm/lib/config/core.js"
+               sed -i -e "s|'/etc'|'${ED}/etc'|g" "${ED}/${npm_config}" || die
+               local tmp_npm_completion_file="$(TMPDIR="${T}" mktemp -t 
npm.XXXXXXXXXX)"
+               "${ED}/usr/bin/npm" completion > "${tmp_npm_completion_file}"
+               newbashcomp "${tmp_npm_completion_file}" npm
+               sed -i -e "s|'${ED}/etc'|'/etc'|g" "${ED}/${npm_config}" || die
+
+               # Move man pages
+               doman "${LIBDIR}"/node_modules/npm/man/man{1,5,7}/*
+
+               # Clean up
+               rm -f 
"${LIBDIR}"/node_modules/npm/{.mailmap,.npmignore,Makefile}
+               rm -rf "${LIBDIR}"/node_modules/npm/{doc,html,man}
+
+               local find_exp="-or -name"
+               local find_name=()
+               for match in "AUTHORS*" "CHANGELOG*" "CONTRIBUT*" "README*" \
+                       ".travis.yml" ".eslint*" ".wercker.yml" ".npmignore" \
+                       "*.md" "*.markdown" "*.bat" "*.cmd"; do
+                       find_name+=( ${find_exp} "${match}" )
+               done
+
+               # Remove various development and/or inappropriate files and
+               # useless docs of dependend packages.
+               find "${LIBDIR}"/node_modules \
+                       \( -type d -name examples \) -or \( -type f \( \
+                               -iname "LICEN?E*" \
+                               "${find_name[@]}" \
+                       \) \) -exec rm -rf "{}" \;
+       fi
+
+       mv "${ED}"/usr/share/doc/node "${ED}"/usr/share/doc/${PF} || die
+}
+
+src_test() {
+       if has usersandbox ${FEATURES}; then
+               rm -f "${S}"/test/parallel/test-fs-mkdir.js
+               ewarn "You are emerging ${PN} with 'usersandbox' enabled. 
Excluding tests known to fail in this mode." \
+                       "For full test coverage, emerge =${CATEGORY}/${PF} with 
'FEATURES=-usersandbox'."
+       fi
+
+       out/${BUILDTYPE}/cctest || die
+       "${PYTHON}" tools/test.py --mode=${BUILDTYPE,,} --flaky-tests=dontcare 
-J message parallel sequential || die
+}
+
+pkg_postinst() {
+       elog "The global npm config lives in /etc/npm. This deviates slightly"
+       elog "from upstream which otherwise would have it live in /usr/etc/."
+       elog ""
+       elog "Protip: When using node-gyp to install native modules, you can"
+       elog "avoid having to download extras by doing the following:"
+       elog "$ node-gyp --nodedir /usr/include/node <command>"
+}

diff --git a/net-libs/nodejs/nodejs-12.22.6.ebuild 
b/net-libs/nodejs/nodejs-12.22.6.ebuild
new file mode 100644
index 000000000000..fc7f6f38aaa1
--- /dev/null
+++ b/net-libs/nodejs/nodejs-12.22.6.ebuild
@@ -0,0 +1,249 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{8..10} )
+PYTHON_REQ_USE="threads(+)"
+
+inherit bash-completion-r1 flag-o-matic pax-utils python-any-r1 
toolchain-funcs xdg-utils
+
+DESCRIPTION="A JavaScript runtime built on Chrome's V8 JavaScript engine"
+HOMEPAGE="https://nodejs.org/";
+LICENSE="Apache-1.1 Apache-2.0 BSD BSD-2 MIT"
+
+if [[ ${PV} == *9999 ]]; then
+       inherit git-r3
+       EGIT_REPO_URI="https://github.com/nodejs/node";
+       SLOT="0"
+else
+       SRC_URI="https://nodejs.org/dist/v${PV}/node-v${PV}.tar.xz";
+       SLOT="0/$(ver_cut 1)"
+       KEYWORDS="amd64 arm arm64 ppc64 -riscv x86 ~amd64-linux ~x64-macos"
+       S="${WORKDIR}/node-v${PV}"
+fi
+
+IUSE="cpu_flags_x86_sse2 debug doc icu inspector lto +npm +snapshot +ssl 
+system-ssl systemtap test"
+REQUIRED_USE="
+       inspector? ( icu ssl )
+       npm? ( ssl )
+       system-ssl? ( ssl )
+"
+
+RESTRICT="!test? ( test )"
+
+RDEPEND="
+       >=app-arch/brotli-1.0.9:=
+       >=dev-libs/libuv-1.39.0:=
+       >=net-dns/c-ares-1.17.2:=
+       >=net-libs/http-parser-2.9.3:=
+       >=net-libs/nghttp2-1.40.0:=
+       sys-libs/zlib
+       icu? ( >=dev-libs/icu-64.2:= )
+       system-ssl? (
+               >=dev-libs/openssl-1.1.1:0=
+               <dev-libs/openssl-3.0.0_beta1:0=
+       )
+"
+BDEPEND="
+       ${PYTHON_DEPS}
+       sys-apps/coreutils
+       virtual/pkgconfig
+       systemtap? ( dev-util/systemtap )
+       test? ( net-misc/curl )
+"
+DEPEND="
+       ${RDEPEND}
+"
+PATCHES=(
+       "${FILESDIR}"/${PN}-10.3.0-global-npm-config.patch
+       "${FILESDIR}"/${PN}-12.20.1-fix_ppc64_crashes.patch
+       "${FILESDIR}"/${PN}-12.22.1-jinja_collections_abc.patch
+       "${FILESDIR}"/${PN}-12.22.1-uvwasi_shared_libuv.patch
+       "${FILESDIR}"/${PN}-12.22.5-shared_c-ares_nameser_h.patch
+       "${FILESDIR}"/${PN}-99999999-llhttp.patch
+)
+
+pkg_pretend() {
+       (use x86 && ! use cpu_flags_x86_sse2) && \
+               die "Your CPU doesn't support the required SSE2 instruction."
+
+       if [[ ${MERGE_TYPE} != "binary" ]]; then
+               if use lto; then
+                       if tc-is-gcc; then
+                               if [[ $(gcc-major-version) -ge 11 ]]; then
+                                       # Bug #787158
+                                       die "LTO builds of ${PN} using gcc-11+ 
currently fail tests and produce runtime errors. Either switch to gcc-10 or 
unset USE=lto for this ebuild"
+                               fi
+                       else
+                               # configure.py will abort on this later if we 
do not
+                               die "${PN} only supports LTO for gcc"
+                       fi
+               fi
+       fi
+}
+
+src_prepare() {
+       tc-export CC CXX PKG_CONFIG
+       export V=1
+       export BUILDTYPE=Release
+
+       # fix compilation on Darwin
+       # https://code.google.com/p/gyp/issues/detail?id=260
+       sed -i -e "/append('-arch/d" tools/gyp/pylib/gyp/xcode_emulation.py || 
die
+
+       # less verbose install output (stating the same as portage, basically)
+       sed -i -e "/print/d" tools/install.py || die
+
+       # proper libdir, hat tip @ryanpcmcquen 
https://github.com/iojs/io.js/issues/504
+       local LIBDIR=$(get_libdir)
+       sed -i -e "s|lib/|${LIBDIR}/|g" tools/install.py || die
+       sed -i -e "s/'lib'/'${LIBDIR}'/" deps/npm/lib/npm.js || die
+
+       # Avoid writing a depfile, not useful
+       sed -i -e "/DEPFLAGS =/d" tools/gyp/pylib/gyp/generator/make.py || die
+
+       sed -i -e "/'-O3'/d" common.gypi node.gypi || die
+
+       # Known-to-fail test of a deprecated, legacy HTTP parser. Just don't 
bother.
+       rm -f test/parallel/test-http-transfer-encoding-smuggling-legacy.js
+
+       # debug builds. change install path, remove optimisations and override 
buildtype
+       if use debug; then
+               sed -i -e "s|out/Release/|out/Debug/|g" tools/install.py || die
+               BUILDTYPE=Debug
+       fi
+
+       default
+}
+
+src_configure() {
+       xdg_environment_reset
+
+       # LTO compiler flags are handled by configure.py itself
+       filter-flags '-flto*'
+
+       local myconf=(
+               --shared-brotli
+               --shared-cares
+               --shared-http-parser
+               --shared-libuv
+               --shared-nghttp2
+               --shared-zlib
+       )
+       use debug && myconf+=( --debug )
+       use lto && myconf+=( --enable-lto )
+       use icu && myconf+=( --with-intl=system-icu ) || myconf+=( 
--with-intl=none )
+       use inspector || myconf+=( --without-inspector )
+       use npm || myconf+=( --without-npm )
+       use snapshot || myconf+=( --without-node-snapshot )
+       if use ssl; then
+               use system-ssl && myconf+=( --shared-openssl 
--openssl-use-def-ca-store )
+       else
+               myconf+=( --without-ssl )
+       fi
+
+       local myarch=""
+       case ${ABI} in
+               amd64) myarch="x64";;
+               arm) myarch="arm";;
+               arm64) myarch="arm64";;
+               ppc64) myarch="ppc64";;
+               x32) myarch="x32";;
+               x86) myarch="ia32";;
+               *) myarch="${ABI}";;
+       esac
+
+       GYP_DEFINES="linux_use_gold_flags=0
+               linux_use_bundled_binutils=0
+               linux_use_bundled_gold=0" \
+       "${EPYTHON}" configure.py \
+               --prefix="${EPREFIX}"/usr \
+               --dest-cpu=${myarch} \
+               $(use_with systemtap dtrace) \
+               "${myconf[@]}" || die
+}
+
+src_compile() {
+       emake -C out mksnapshot
+       pax-mark m "out/${BUILDTYPE}/mksnapshot"
+       emake -C out
+}
+
+src_install() {
+       local LIBDIR="${ED}/usr/$(get_libdir)"
+       default
+
+       pax-mark -m "${ED}"/usr/bin/node
+
+       # set up a symlink structure that node-gyp expects..
+       dodir /usr/include/node/deps/{v8,uv}
+       dosym . /usr/include/node/src
+       for var in deps/{uv,v8}/include; do
+               dosym ../.. /usr/include/node/${var}
+       done
+
+       if use doc; then
+               docinto html
+               dodoc -r "${S}"/doc/*
+       fi
+
+       if use npm; then
+               dodir /etc/npm
+
+               # Install bash completion for `npm`
+               # We need to temporarily replace default config path since
+               # npm otherwise tries to write outside of the sandbox
+               local 
npm_config="usr/$(get_libdir)/node_modules/npm/lib/config/core.js"
+               sed -i -e "s|'/etc'|'${ED}/etc'|g" "${ED}/${npm_config}" || die
+               local tmp_npm_completion_file="$(TMPDIR="${T}" mktemp -t 
npm.XXXXXXXXXX)"
+               "${ED}/usr/bin/npm" completion > "${tmp_npm_completion_file}"
+               newbashcomp "${tmp_npm_completion_file}" npm
+               sed -i -e "s|'${ED}/etc'|'/etc'|g" "${ED}/${npm_config}" || die
+
+               # Move man pages
+               doman "${LIBDIR}"/node_modules/npm/man/man{1,5,7}/*
+
+               # Clean up
+               rm -f 
"${LIBDIR}"/node_modules/npm/{.mailmap,.npmignore,Makefile}
+               rm -rf "${LIBDIR}"/node_modules/npm/{doc,html,man}
+
+               local find_exp="-or -name"
+               local find_name=()
+               for match in "AUTHORS*" "CHANGELOG*" "CONTRIBUT*" "README*" \
+                       ".travis.yml" ".eslint*" ".wercker.yml" ".npmignore" \
+                       "*.md" "*.markdown" "*.bat" "*.cmd"; do
+                       find_name+=( ${find_exp} "${match}" )
+               done
+
+               # Remove various development and/or inappropriate files and
+               # useless docs of dependend packages.
+               find "${LIBDIR}"/node_modules \
+                       \( -type d -name examples \) -or \( -type f \( \
+                               -iname "LICEN?E*" \
+                               "${find_name[@]}" \
+                       \) \) -exec rm -rf "{}" \;
+       fi
+
+       mv "${ED}"/usr/share/doc/node "${ED}"/usr/share/doc/${PF} || die
+}
+
+src_test() {
+       if has usersandbox ${FEATURES}; then
+               rm -f "${S}"/test/parallel/test-fs-mkdir.js
+               ewarn "You are emerging ${PN} with 'usersandbox' enabled. 
Excluding tests known to fail in this mode." \
+                       "For full test coverage, emerge =${CATEGORY}/${PF} with 
'FEATURES=-usersandbox'."
+       fi
+
+       out/${BUILDTYPE}/cctest || die
+       "${PYTHON}" tools/test.py --mode=${BUILDTYPE,,} --flaky-tests=dontcare 
-J message parallel sequential || die
+}
+
+pkg_postinst() {
+       elog "The global npm config lives in /etc/npm. This deviates slightly"
+       elog "from upstream which otherwise would have it live in /usr/etc/."
+       elog ""
+       elog "Protip: When using node-gyp to install native modules, you can"
+       elog "avoid having to download extras by doing the following:"
+       elog "$ node-gyp --nodedir /usr/include/node <command>"
+}

Reply via email to